searchNodes=[{"doc":"Crawly is a fast high-level web crawling &amp; scraping framework for Elixir.","ref":"Crawly.html","title":"Crawly","type":"module"},{"doc":"Fetches a given url. This function is mainly used for the spiders development when you need to get individual pages and parse them. The fetched URL is being converted to a request, and the request is piped through the middlewares specified in a config (with the exception of Crawly.Middlewares.DomainFilter , Crawly.Middlewares.RobotsTxt ) Provide a spider with the :with option to fetch a given webpage using that spider. Fetching with a spider To fetch a response from a url with a spider, define your spider, and pass the module name to the :with option. iex&gt; Crawly.fetch(&quot; https://www.example.com&quot;, with: MySpider) {%HTTPoison.Response{...}, %{...}, [...], %{...}} Using the :with option will return a 4 item tuple: The HTTPoison response The result returned from the parse_item/1 callback The list of items that have been processed by the declared item pipelines. The pipeline state, included for debugging purposes.","ref":"Crawly.html#fetch/2","title":"Crawly.fetch/2","type":"function"},{"doc":"Returns a list of known modules which implements Crawly.Spider behaviour. Should not be used for spider management. Use functions defined in Crawly.Engine for that.","ref":"Crawly.html#list_spiders/0","title":"Crawly.list_spiders/0","type":"function"},{"doc":"Loads spiders from a given directory and the simple storage","ref":"Crawly.html#load_spiders/0","title":"Crawly.load_spiders/0","type":"function"},{"doc":"Parses a given response with a given spider. Allows to quickly see the outcome of the given :parse_item implementation.","ref":"Crawly.html#parse/2","title":"Crawly.parse/2","type":"function"},{"doc":"","ref":"Crawly.html#t:headers_opt/0","title":"Crawly.headers_opt/0","type":"type"},{"doc":"","ref":"Crawly.html#t:parsed_item_result/0","title":"Crawly.parsed_item_result/0","type":"type"},{"doc":"","ref":"Crawly.html#t:parsed_items/0","title":"Crawly.parsed_items/0","type":"type"},{"doc":"","ref":"Crawly.html#t:pipeline_state/0","title":"Crawly.pipeline_state/0","type":"type"},{"doc":"","ref":"Crawly.html#t:request_opt/0","title":"Crawly.request_opt/0","type":"type"},{"doc":"","ref":"Crawly.html#t:spider/0","title":"Crawly.spider/0","type":"type"},{"doc":"","ref":"Crawly.html#t:with_opt/0","title":"Crawly.with_opt/0","type":"type"},{"doc":"Crawly HTTP API. Allows to schedule/stop/get_stats of all running spiders.","ref":"Crawly.API.Router.html","title":"Crawly.API.Router","type":"module"},{"doc":"Callback implementation for Plug.call/2 .","ref":"Crawly.API.Router.html#call/2","title":"Crawly.API.Router.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1 .","ref":"Crawly.API.Router.html#init/1","title":"Crawly.API.Router.init/1","type":"function"},{"doc":"","ref":"Crawly.API.Router.html#put_base_path/2","title":"Crawly.API.Router.put_base_path/2","type":"function"},{"doc":"A behavior module for defining Crawly Fetchers A fetcher is expected to implement a fetch callback which should take Crawly.Request, HTTP client options and return Crawly.Response.","ref":"Crawly.Fetchers.Fetcher.html","title":"Crawly.Fetchers.Fetcher","type":"behaviour"},{"doc":"","ref":"Crawly.Fetchers.Fetcher.html#c:fetch/2","title":"Crawly.Fetchers.Fetcher.fetch/2","type":"callback"},{"doc":"","ref":"Crawly.Fetchers.Fetcher.html#t:t/0","title":"Crawly.Fetchers.Fetcher.t/0","type":"type"},{"doc":"Implements Crawly.Fetchers.Fetcher behavior based on HTTPoison HTTP client","ref":"Crawly.Fetchers.HTTPoisonFetcher.html","title":"Crawly.Fetchers.HTTPoisonFetcher","type":"module"},{"doc":"Callback implementation for Crawly.Fetchers.Fetcher.fetch/2 .","ref":"Crawly.Fetchers.HTTPoisonFetcher.html#fetch/2","title":"Crawly.Fetchers.HTTPoisonFetcher.fetch/2","type":"function"},{"doc":"Implements Crawly.Fetchers.Fetcher behavior for Splash Javascript rendering. Splash is a lightweight QT based Javascript rendering engine. See: https://splash.readthedocs.io/ Splash exposes the render.html endpoint which renders incoming requests sent with ?url get parameter. This particular Splash fetcher converts all requests made by Crawly to Splash requests, and cleans up the final responses, by removing the Splash parts from the response. It's possible to start splash server in any documented way. One of the options is to run it locally with a help of docker: docker run -it -p 8050:8050 scrapinghub/splash In this case you have to configure the fetcher in the following way: fetcher: {Crawly.Fetchers.Splash, [base_url: &quot;http://localhost:8050/render.html&quot;]},","ref":"Crawly.Fetchers.Splash.html","title":"Crawly.Fetchers.Splash","type":"module"},{"doc":"Callback implementation for Crawly.Fetchers.Fetcher.fetch/2 .","ref":"Crawly.Fetchers.Splash.html#fetch/2","title":"Crawly.Fetchers.Splash.fetch/2","type":"function"},{"doc":"","ref":"Crawly.Loggers.SendToUiBackend.html","title":"Crawly.Loggers.SendToUiBackend","type":"module"},{"doc":"","ref":"Crawly.Loggers.SendToUiBackend.html#handle_call/2","title":"Crawly.Loggers.SendToUiBackend.handle_call/2","type":"function"},{"doc":"","ref":"Crawly.Loggers.SendToUiBackend.html#handle_event/2","title":"Crawly.Loggers.SendToUiBackend.handle_event/2","type":"function"},{"doc":"","ref":"Crawly.Loggers.SendToUiBackend.html#init/1","title":"Crawly.Loggers.SendToUiBackend.init/1","type":"function"},{"doc":"The Crawly.Models.Job module defines a struct and functions for managing and updating information about a web scraping job. Struct The Crawly.Models.Job struct has the following fields: id : a binary representing the unique ID of the job. spider_name : a binary representing the name of the spider used for the job. start : a DateTime.t representing the time the job started. end : a DateTime.t representing the time the job ended. This is nil until the job is completed. scraped_items : an integer representing the number of items scraped during the job. stop_reason : a binary representing the reason the job was stopped, if applicable. This is nil until the job is stopped. Functions new(crawl_id, spider_name) : creates a new job with the given crawl_id and spider_name and stores it in a SimpleStorage instance. update(crawl_id, total_scraped, stop_reason) : updates the job with the given crawl_id with the total number of items total_scraped and the reason stop_reason , and stores it in the SimpleStorage instance. get(crawl_id) : retrieves the job with the given crawl_id from the SimpleStorage instance.","ref":"Crawly.Models.Job.html","title":"Crawly.Models.Job","type":"module"},{"doc":"Retrieves the job with the given crawl_id from the SimpleStorage instance. ## Examples iex&gt; Crawly.Models.Job . get ( &quot;my-crawl-id&quot; ) { :ok , % Crawly.Models.Job { id : &quot;my-crawl-id&quot; , spider_name : &quot;my-spider&quot; , start : ~U[2023-03-31 16:00:00Z] , end : nil , scraped_items : 0 , stop_reason : nil } } ## Parameters crawl_id : a binary representing the unique ID of the job. ## Returns {:ok, job} : a tuple containing the retrieved job as a Crawly.Models.Job struct if it exists in the SimpleStorage instance. {:error, reason} : a tuple containing the reason why the job could not be retrieved, such as if it does not exist in the SimpleStorage instance.","ref":"Crawly.Models.Job.html#get/1","title":"Crawly.Models.Job.get/1","type":"function"},{"doc":"List all registered jobs","ref":"Crawly.Models.Job.html#list/0","title":"Crawly.Models.Job.list/0","type":"function"},{"doc":"Creates a new job with the given crawl_id and spider_name , and stores it in the SimpleStorage instance. ## Examples iex&gt; Crawly.Models.Job . new ( &quot;my-crawl-id&quot; , &quot;my-spider&quot; ) :ok ## Parameters crawl_id : a binary representing the unique ID of the job. spider_name : a binary representing the name of the spider used for the job. ## Returns :ok : if the job was created and stored successfully. {:error, reason} : if an error occurred while trying to create or store the job.","ref":"Crawly.Models.Job.html#new/2","title":"Crawly.Models.Job.new/2","type":"function"},{"doc":"Updates the job with the given crawl_id in the SimpleStorage instance with the provided total_scraped and stop_reason . ## Examples iex&gt; Crawly.Models.Job . update ( &quot;my-crawl-id&quot; , 100 , :finished ) :ok ## Parameters crawl_id : a binary representing the unique ID of the job. total_scraped : an integer representing the total number of items scraped during the job. stop_reason : a term representing the reason why the job was stopped, if applicable. ## Returns :ok : if the job was successfully updated in the SimpleStorage instance. {:error, reason} : a tuple containing the reason why the job could not be updated, such as if it does not exist in the SimpleStorage instance.","ref":"Crawly.Models.Job.html#update/3","title":"Crawly.Models.Job.update/3","type":"function"},{"doc":"","ref":"Crawly.Models.Job.html#t:t/0","title":"Crawly.Models.Job.t/0","type":"type"},{"doc":"","ref":"Crawly.Models.YMLSpider.html","title":"Crawly.Models.YMLSpider","type":"module"},{"doc":"Deletes a given spider from the SimpleStorage","ref":"Crawly.Models.YMLSpider.html#delete/1","title":"Crawly.Models.YMLSpider.delete/1","type":"function"},{"doc":"Get spider YML from the storage Arguments: spider_name : The name of the spider configuration to store. This can be any Erlang term. Returns: {:ok, spider_yml} if the storage operation was successful. {:error, reason} if the storage operation failed for some reason. reason can be any term. Example usage: Crawly.Models.YMLSpider.get(Books)","ref":"Crawly.Models.YMLSpider.html#get/1","title":"Crawly.Models.YMLSpider.get/1","type":"function"},{"doc":"List all spiders in SimpleStorage","ref":"Crawly.Models.YMLSpider.html#list/0","title":"Crawly.Models.YMLSpider.list/0","type":"function"},{"doc":"Iterates through a list of spider configurations, loads them.","ref":"Crawly.Models.YMLSpider.html#load/0","title":"Crawly.Models.YMLSpider.load/0","type":"function"},{"doc":"Loads a YAML binary as Spider module Args: yml_binary: A binary representation of a YAML spider. Raises an error if there is a problem parsing the YAML document or evaluating the Elixir code template. Example: iex&gt; yml_binary = &quot;name: my_spider&quot; iex&gt; load(yml_binary) {:ok, %{name: &quot;my_spider&quot;}, []}","ref":"Crawly.Models.YMLSpider.html#load/1","title":"Crawly.Models.YMLSpider.load/1","type":"function"},{"doc":"Stores the YAML binary data for a spider configuration in a persistent storage backend. Arguments: spider_name : The name of the spider configuration to store. This can be any Erlang term. yml_binary : A binary string containing the YAML data for the spider configuration. Returns: :ok if the storage operation was successful. {:error, reason} if the storage operation failed for some reason. reason can be any term. Example usage: Crawly.Models.YMLSpider.new(Books, &quot;YML spider code&quot;)","ref":"Crawly.Models.YMLSpider.html#new/2","title":"Crawly.Models.YMLSpider.new/2","type":"function"},{"doc":"Define Crawly setting types","ref":"Crawly.Settings.html","title":"Crawly.Settings","type":"module"},{"doc":"","ref":"Crawly.Settings.html#t:middleware/0","title":"Crawly.Settings.middleware/0","type":"type"},{"doc":"","ref":"Crawly.Settings.html#t:numeric_setting/0","title":"Crawly.Settings.numeric_setting/0","type":"type"},{"doc":"","ref":"Crawly.Settings.html#t:pipeline/0","title":"Crawly.Settings.pipeline/0","type":"type"},{"doc":"","ref":"Crawly.Settings.html#t:retry/0","title":"Crawly.Settings.retry/0","type":"type"},{"doc":"","ref":"Crawly.Settings.html#t:t/0","title":"Crawly.Settings.t/0","type":"type"},{"doc":"","ref":"Crawly.SimpleStorage.html","title":"Crawly.SimpleStorage","type":"module"},{"doc":"Deletes all objects from the storage iex(17)&gt; Crawly.SimpleStorage.clear() :ok","ref":"Crawly.SimpleStorage.html#clear/0","title":"Crawly.SimpleStorage.clear/0","type":"function"},{"doc":"Deletes a given object iex(17)&gt; Crawly.SimpleStorage.delete(:siders, Test1) :ok","ref":"Crawly.SimpleStorage.html#delete/2","title":"Crawly.SimpleStorage.delete/2","type":"function"},{"doc":"Return value for the given key from the term storage. iex(1)&gt; Crawly.SimpleStorage.get(:spiders, Test) iex(1)&gt; Crawly.SimpleStorage.get(:spiders, T)","ref":"Crawly.SimpleStorage.html#get/2","title":"Crawly.SimpleStorage.get/2","type":"function"},{"doc":"Initialize storage to store spiders information","ref":"Crawly.SimpleStorage.html#init/0","title":"Crawly.SimpleStorage.init/0","type":"function"},{"doc":"Makes a simple list from the simple storage. iex(17)&gt; Crawly.SimpleStorage.list(:spiders) [Test4, Test3, Test2, Test1, Test]","ref":"Crawly.SimpleStorage.html#list/1","title":"Crawly.SimpleStorage.list/1","type":"function"},{"doc":"Insert a given object in a term storage iex(1)&gt; Crawly.SimpleStorage.put(:spiders, Test, &quot;12345&quot;) :ok","ref":"Crawly.SimpleStorage.html#put/3","title":"Crawly.SimpleStorage.put/3","type":"function"},{"doc":"Utility functions for Crawly","ref":"Crawly.Utils.html","title":"Crawly.Utils","type":"module"},{"doc":"A helper function which joins relative url with a base URL","ref":"Crawly.Utils.html#build_absolute_url/2","title":"Crawly.Utils.build_absolute_url/2","type":"function"},{"doc":"A helper function which joins relative url with a base URL for a list","ref":"Crawly.Utils.html#build_absolute_urls/2","title":"Crawly.Utils.build_absolute_urls/2","type":"function"},{"doc":"Remove all previousely registered dynamic spiders","ref":"Crawly.Utils.html#clear_registered_spiders/0","title":"Crawly.Utils.clear_registered_spiders/0","type":"function"},{"doc":"Wrapper function for Code.ensure_loaded?/1 to allow mocking","ref":"Crawly.Utils.html#ensure_loaded?/1","title":"Crawly.Utils.ensure_loaded?/1","type":"function"},{"doc":"A helper function that is used by YML spiders Extract items (actually one item) from a given document using a given set of selectors. Selectors are aprovided as a JSON encoded list of maps, that contain name and selector binary keys. For example: field_selectors = [%{&quot;selector&quot; =&gt; &quot;h1&quot;, &quot;name&quot; =&gt; &quot;title&quot;}]","ref":"Crawly.Utils.html#extract_items/2","title":"Crawly.Utils.extract_items/2","type":"function"},{"doc":"A helper function that is used by YML spiders Extract requests from a given document using a given set of selectors builds absolute_urls. Selectors are aprovided as a JSON encoded list of maps, that contain selector and attribute keys. E.g. selectors = [%{&quot;selector&quot; =&gt; &quot;a&quot;, &quot;attribute&quot; =&gt; &quot;href&quot;}] Base URL is required to build absolute url from extracted links","ref":"Crawly.Utils.html#extract_requests/3","title":"Crawly.Utils.extract_requests/3","type":"function"},{"doc":"","ref":"Crawly.Utils.html#get_modules_from_applications/0","title":"Crawly.Utils.get_modules_from_applications/0","type":"function"},{"doc":"A helper which allows to extract a given setting. Returned value is a result of intersection of the global settings and settings defined as settings_override inside the spider. Settings defined on spider are taking precedence over the global settings defined in the config.","ref":"Crawly.Utils.html#get_settings/3","title":"Crawly.Utils.get_settings/3","type":"function"},{"doc":"Returns a list of known modules which implements Crawly.Spider behaviour","ref":"Crawly.Utils.html#list_spiders/0","title":"Crawly.Utils.list_spiders/0","type":"function"},{"doc":"Loads spiders from a given directory. Store thm in persistant term under :spiders This allows to readup spiders stored in specific directory which is not a part of Crawly application","ref":"Crawly.Utils.html#load_spiders/0","title":"Crawly.Utils.load_spiders/0","type":"function"},{"doc":"Pipeline/Middleware helper Executes a given list of pipelines on the given item, mimics filtermap behavior. Takes an item and state and passes it through a list of modules which implements a pipeline behavior, executing the pipeline's Crawly.Pipeline.run/3 function. The pipe function must either return a boolean ( false ), or an updated item. If false is returned by a pipeline, the item is dropped. It will not be processed by any descendant pipelines. In case of a pipeline crash, the pipeline will be skipped and the item will be passed on to descendant pipelines. The state variable is used to persist the information across multiple items. Usage in Tests The Crawly.Utils.pipe/3 helper can be used in pipeline testing to simulate a set of middlewares/pipelines. Internally, this function is used for both middlewares and pipelines. Hence, you can use it for testing modules that implement the Crawly.Pipeline behaviour. For example, one can test that a given item is manipulated by a pipeline as so: item = %{ my : &quot;item&quot; } state = %{ } pipelines = [ MyCustomPipelineOrMiddleware ] { new_item , new_state } = Crawly.Utils . pipe ( pipelines , item , state )","ref":"Crawly.Utils.html#pipe/3","title":"Crawly.Utils.pipe/3","type":"function"},{"doc":"A helper function that allows to preview spider results based on a given YML","ref":"Crawly.Utils.html#preview/1","title":"Crawly.Utils.preview/1","type":"function"},{"doc":"Register a given spider (so it's visible in the spiders list)","ref":"Crawly.Utils.html#register_spider/1","title":"Crawly.Utils.register_spider/1","type":"function"},{"doc":"Return a list of registered spiders","ref":"Crawly.Utils.html#registered_spiders/0","title":"Crawly.Utils.registered_spiders/0","type":"function"},{"doc":"A helper function which returns a Request structure for the given URL","ref":"Crawly.Utils.html#request_from_url/1","title":"Crawly.Utils.request_from_url/1","type":"function"},{"doc":"A helper function which converts a list of URLS into a requests list.","ref":"Crawly.Utils.html#requests_from_urls/1","title":"Crawly.Utils.requests_from_urls/1","type":"function"},{"doc":"A wrapper over Process.send after This wrapper should be used instead of Process.send_after, so it's possible to mock the last one. To avoid race conditions on worker's testing.","ref":"Crawly.Utils.html#send_after/3","title":"Crawly.Utils.send_after/3","type":"function"},{"doc":"Composes the log file path for a given spider and crawl ID. Args: spider_name (atom): The name of the spider to create the log path for. crawl_id (string): The ID of the crawl to create the log path for. Returns: string: The file path to the log file for the given spider and crawl ID. Examples: iex&gt; spider_log_path(:my_spider, &quot;crawl_123&quot;) &quot;/tmp/crawly/my_spider/crawl_123.log&quot; iex&gt; spider_log_path(:my_spider, &quot;crawl_456&quot;) &quot;/tmp/crawly/my_spider/crawl_456.log&quot;","ref":"Crawly.Utils.html#spider_log_path/2","title":"Crawly.Utils.spider_log_path/2","type":"function"},{"doc":"Function to get setting module in proper data structure","ref":"Crawly.Utils.html#unwrap_module_and_options/1","title":"Crawly.Utils.unwrap_module_and_options/1","type":"function"},{"doc":"Generate Crawly configuration A small helper that generates a crawly spider configuration","ref":"Mix.Tasks.Crawly.Gen.Config.html","title":"Mix.Tasks.Crawly.Gen.Config","type":"task"},{"doc":"Generate Crawly spider template Reduce a bit of the boilerplate by providing spider generator function The generator function is used to generate a spider template for a given website. --filepath - specify a filepath where the spider is supposed to be generated (required) --spidername - specify a name of the spider module (required) --help - show this message","ref":"Mix.Tasks.Crawly.Gen.Spider.html","title":"Mix.Tasks.Crawly.Gen.Spider","type":"task"},{"doc":"Defines the structure of spider's result. Usage with Parsers A %ParsedItem{} is piped through each parser pipeline module when it is declared. Refer to Crawly.Pipeline for further documentation.","ref":"Crawly.ParsedItem.html","title":"Crawly.ParsedItem","type":"module"},{"doc":"","ref":"Crawly.ParsedItem.html#t:item/0","title":"Crawly.ParsedItem.item/0","type":"type"},{"doc":"","ref":"Crawly.ParsedItem.html#t:t/0","title":"Crawly.ParsedItem.t/0","type":"type"},{"doc":"Request wrapper Defines Crawly request structure.","ref":"Crawly.Request.html","title":"Crawly.Request","type":"module"},{"doc":"Create new Crawly.Request from url, headers and options","ref":"Crawly.Request.html#new/3","title":"Crawly.Request.new/3","type":"function"},{"doc":"Same as Crawly.Request.new/3 from but allows to specify middlewares as the 4th parameter.","ref":"Crawly.Request.html#new/4","title":"Crawly.Request.new/4","type":"function"},{"doc":"","ref":"Crawly.Request.html#t:header/0","title":"Crawly.Request.header/0","type":"type"},{"doc":"","ref":"Crawly.Request.html#t:option/0","title":"Crawly.Request.option/0","type":"type"},{"doc":"","ref":"Crawly.Request.html#t:t/0","title":"Crawly.Request.t/0","type":"type"},{"doc":"","ref":"Crawly.Request.html#t:url/0","title":"Crawly.Request.url/0","type":"type"},{"doc":"Define Crawly response structure","ref":"Crawly.Response.html","title":"Crawly.Response","type":"module"},{"doc":"","ref":"Crawly.Response.html#t:t/0","title":"Crawly.Response.t/0","type":"type"},{"doc":"A behavior module for implementing a Crawly Spider A Spider is a module which is responsible for defining: init/0 function, which must return a keyword list with start_urls/start_requests list init/1 same as init, but also takes a list of options sent from Engine base_url/0 function responsible for filtering out requests not related to a given website override_settings/0 function that is called each time a setting is referenced internally. Allows overriding of Crawly configuration at the spider-level. parse_item/1 function which is responsible for parsing the downloaded request and converting it into items which can be stored and new requests which can be scheduled custom_settings/0 an optional callback which can be used in order to provide custom spider specific settings. Should define a list with custom settings and their values. These values will take precedence over the global settings defined in the config.","ref":"Crawly.Spider.html","title":"Crawly.Spider","type":"behaviour"},{"doc":"","ref":"Crawly.Spider.html#c:base_url/0","title":"Crawly.Spider.base_url/0","type":"callback"},{"doc":"","ref":"Crawly.Spider.html#c:init/0","title":"Crawly.Spider.init/0","type":"callback"},{"doc":"","ref":"Crawly.Spider.html#c:init/1","title":"Crawly.Spider.init/1","type":"callback"},{"doc":"","ref":"Crawly.Spider.html#c:override_settings/0","title":"Crawly.Spider.override_settings/0","type":"callback"},{"doc":"","ref":"Crawly.Spider.html#c:parse_item/1","title":"Crawly.Spider.parse_item/1","type":"callback"},{"doc":"A behavior module for implementing a pipeline module. Pipelines allow for customization of how Crawly.Requests , Crawly.Responses , and :items set on Crawly.ParsedItem are processed. Each pipeline is called in sequence, with the result of each being passed to the next pipeline. A pipeline is a module which takes a given item, and executes a run callback on a given item. A state argument is used to share common information across multiple items. May have preset keys that are set internally by Crawly. Custom pipeline modules may set information to be further used down the declared list of pipeline modules. An opts argument is used to pass configuration to the pipeline through tuple-based declarations. Example Config Declaration # config.exs :crawly , parsers : [ # with options { Crawly.ExtractRequests , selector : &quot;a&quot; } ] , middlewares : [ Crawly.Middlewares.DomainFilter , Crawly.Middlewares.UniqueRequest , Crawly.Middlewares.RobotsTxt ] , pipelines : [ Crawly.Pipelines.JSONEncoder ] Request Middlewares Request middlewares are called for each request returned on the :requests key of a ParsedItem . Response Parsers The following are set on the state for parsers: :response : A Crawly.Response struct. The response from the used Fetcher . :spider_name : The name of the spider that is is currently being used. Can be used for processing customizations, logging, or referencing settings. Must return a Map on the first tuple position, which follows the same typespecs as a ParsedItem . Only recognized keys will be used. Item Pipelines Item pipelines are called for each enumerable result on the :items key of a ParsedItem .","ref":"Crawly.Pipeline.html","title":"Crawly.Pipeline","type":"behaviour"},{"doc":"","ref":"Crawly.Pipeline.html#c:run/2","title":"Crawly.Pipeline.run/2","type":"callback"},{"doc":"","ref":"Crawly.Pipeline.html#c:run/3","title":"Crawly.Pipeline.run/3","type":"callback"},{"doc":"Set/update cookies for requests. The cookies are being automatically picked up from prev_responses stored by Crawly. Only name/value pairs are taken into account, all other options like domain, secure and others are ignored. Example Declaration middlewares : [ Crawly.Middlewares.AutoCookiesManager ]","ref":"Crawly.Middlewares.AutoCookiesManager.html","title":"Crawly.Middlewares.AutoCookiesManager","type":"module"},{"doc":"","ref":"Crawly.Middlewares.AutoCookiesManager.html#run/2","title":"Crawly.Middlewares.AutoCookiesManager.run/2","type":"function"},{"doc":"Filters out requests which are going outside of the crawled domain. The domain that is used to compare against the request url is obtained from the spider's c:Crawly.Spider.base_url callback. Does not accept any options. Tuple-based configuration options will be ignored. Example Declaration middlewares : [ Crawly.Middlewares.DomainFilter ]","ref":"Crawly.Middlewares.DomainFilter.html","title":"Crawly.Middlewares.DomainFilter","type":"module"},{"doc":"Callback implementation for Crawly.Pipeline.run/3 .","ref":"Crawly.Middlewares.DomainFilter.html#run/3","title":"Crawly.Middlewares.DomainFilter.run/3","type":"function"},{"doc":"Request settings middleware Allows to specify HTTP request settings like follow_redirect, or request timeout. If using HTTPoisonFetcher (the default), please refer to the HTTPoison Request documentation for full list of :options . Example Usage Example Declaration middlewares : [ { Crawly.Middlewares.RequestOptions , [ timeout : 30_000 , recv_timeout : 15000 ] } ] Declaring proxy settings middlewares : [ { Crawly.Middlewares.RequestOptions , [ proxy : { &quot;https://my_host.com&quot; , 3000 } , proxy_auth : { &quot;my_user&quot; , &quot; my_password } ] } ]","ref":"Crawly.Middlewares.RequestOptions.html","title":"Crawly.Middlewares.RequestOptions","type":"module"},{"doc":"Callback implementation for Crawly.Pipeline.run/3 .","ref":"Crawly.Middlewares.RequestOptions.html#run/3","title":"Crawly.Middlewares.RequestOptions.run/3","type":"function"},{"doc":"Obey robots.txt A robots.txt file tells search engine crawlers which pages or files the crawler can or can't request from your site. This is used mainly to avoid overloading a site with requests! No options are required for this middleware. Any tuple-based configurations options passed will be ignored. Example Declaration middlewares : [ Crawly.Middlewares.RobotsTxt ]","ref":"Crawly.Middlewares.RobotsTxt.html","title":"Crawly.Middlewares.RobotsTxt","type":"module"},{"doc":"Callback implementation for Crawly.Pipeline.run/3 .","ref":"Crawly.Middlewares.RobotsTxt.html#run/3","title":"Crawly.Middlewares.RobotsTxt.run/3","type":"function"},{"doc":"Filters out requests which are going outside of the crawled domain. The domain that is used to compare against the request url is obtained from the previous response, so it ends up being the spider's start_url. Spider's base_url is not evaluated. Does not accept any options. Tuple-based configuration optionswill be ignored. Example Declaration middlewares : [ Crawly.Middlewares.SameDomainFilter ]","ref":"Crawly.Middlewares.SameDomainFilter.html","title":"Crawly.Middlewares.SameDomainFilter","type":"module"},{"doc":"Callback implementation for Crawly.Pipeline.run/3 .","ref":"Crawly.Middlewares.SameDomainFilter.html#run/3","title":"Crawly.Middlewares.SameDomainFilter.run/3","type":"function"},{"doc":"Avoid scheduling multiple requests for the same page. Allow to set a hashing algorithm via options to reduce the memory footprint. Be aware of reduced collision resistance, depending on the chosen algorithm. Example Declarations middlewares : [ Crawly.Middlewares.UniqueRequest ] middlewares : [ { Crawly.Middlewares.UniqueRequest , hash : :sha } ] See the Erlang documentation for crypto for available algorithms.","ref":"Crawly.Middlewares.UniqueRequest.html","title":"Crawly.Middlewares.UniqueRequest","type":"module"},{"doc":"","ref":"Crawly.Middlewares.UniqueRequest.html#run/3","title":"Crawly.Middlewares.UniqueRequest.run/3","type":"function"},{"doc":"Set/Rotate user agents for crawling. The user agents are read from :crawly, :user_agents sessions. The default value for the user agent is: Crawly Bot 1.0 Rotation is determined through Enum.random/1 . Options :user_agents , optional. A list of user agent strings to rotate. Defaults to &quot;Crawly Bot 1.0&quot;. Example Declaration middlewares : [ { UserAgent , user_agents : [ &quot;My Custom Bot&quot; ] } ]","ref":"Crawly.Middlewares.UserAgent.html","title":"Crawly.Middlewares.UserAgent","type":"module"},{"doc":"","ref":"Crawly.Middlewares.UserAgent.html#run/3","title":"Crawly.Middlewares.UserAgent.run/3","type":"function"},{"doc":"Encodes a given item (map) into CSV. Does not flatten nested maps. Options If no fields are given, the item is dropped from the pipeline. :fields , required: The fields to extract out from the scraped item. Falls back to the global config :item . Example Usage iex&gt; item = %{my: &quot;first&quot;, other: &quot;second&quot;, ignore: &quot;this_field&quot;} iex&gt; Crawly.Pipelines.CSVEncoder.run(item, %{}, fields: [:my, :other]) {&quot;first,second&quot;, %{}}","ref":"Crawly.Pipelines.CSVEncoder.html","title":"Crawly.Pipelines.CSVEncoder","type":"module"},{"doc":"Filters out duplicated items based on the provided item_id . Stores identifier values in state under the :duplicates_filter key. Options If item unique identifier is not provided, this pipeline does nothing. :item_id , required: Designates a field to be used to check for duplicates. Falls back to global config :item_id . Example Usage iex&gt; item = %{ my : &quot;item&quot; } iex&gt; { _unchanged , new_state } = DuplicatesFilter . run ( first , %{ } , item_id : :my ) # Rerunning the item through the pipeline will drop the item iex&gt; DuplicatesFilter . run ( first , %{ } , item_id : :id ) { false , %{ duplicates_filter : %{ &quot;item&quot; =&gt; true } } }","ref":"Crawly.Pipelines.DuplicatesFilter.html","title":"Crawly.Pipelines.DuplicatesFilter","type":"module"},{"doc":"","ref":"Crawly.Pipelines.Experimental.SendToUI.html","title":"Crawly.Pipelines.Experimental.SendToUI","type":"module"},{"doc":"Encodes a given item (map) into JSON No options are available for this pipeline. Example Declaration pipelines : [ Crawly.Pipelines.JSONEncoder ] Example Usage iex&gt; JSONEncoder . run ( %{ my : &quot;field&quot; } , %{ } ) { &quot;{&quot; my &quot;:&quot; field &quot;}&quot; , %{ } }","ref":"Crawly.Pipelines.JSONEncoder.html","title":"Crawly.Pipelines.JSONEncoder","type":"module"},{"doc":"Ensure that scraped item contains a set of required fields. Options If the fields to check are not provided, the pipeline does nothing. :fields , required: The list of required fields. Fallsback to global config :item . Example Declaration pipelines : [ { Crawly.Pipelines.Validate , fields : [ :id , :url , :date ] } ] Example Usage # Drops the scraped item that does not have the required fields iex&gt; Validate . run ( %{ my : &quot;field&quot; } , %{ } , fields : [ :id ] ) { false , %{ } }","ref":"Crawly.Pipelines.Validate.html","title":"Crawly.Pipelines.Validate","type":"module"},{"doc":"Stores a given item into Filesystem Pipeline Lifecycle: When run (by Crawly.Utils.pipe ), creates a file descriptor if not already created. Performs the write operation File descriptor is reused by passing it through the pipeline state with :write_to_file_fd Note: File.close is not necessary due to the file descriptor being automatically closed upon the end of a the parent process. Refer to https://github.com/oltarasenko/crawly/pull/19#discussion_r350599526 for relevant discussion. Options In the absence of tuple-based options being passed, the pipeline will fallback onto the config of :crawly , Crawly.Pipelines.WriteToFile , for the :folder and :extension keys :folder , optional. The folder in which the file will be created. Defaults to current project's folder. If provided folder does not exist it's created. :extension , optional. The file extension in which the file will be created with. Defaults to jl . :include_timestamp , boolean, optional, true by default. Allows to add timestamp to the filename. Example Declaration pipelines : [ Crawly.Pipelines.JSONEncoder , { Crawly.Pipelines.WriteToFile , folder : &quot;/tmp&quot; , extension : &quot;csv&quot; } ] Example Output iex&gt; item = %{ my : &quot;item&quot; } iex&gt; WriteToFile . run ( item , %{ } , folder : &quot;/tmp&quot; , extension : &quot;csv&quot; ) { %{ my : &quot;item&quot; } , %{ write_to_file_fd : # PID &lt; 0 . 123 . 0 &gt; } }","ref":"Crawly.Pipelines.WriteToFile.html","title":"Crawly.Pipelines.WriteToFile","type":"module"},{"doc":"Data Storage, is a module responsible for storing crawled items. On the high level it's possible to represent the architecture of items storage this way: ┌ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ┐ │ │ ┌ -- -- -- -- -- -- -- -- -- ┐ │ DataStorage &lt; ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ┤ From crawlers1 , 2 │ │ │ └ -- -- -- -- -- -- -- -- -- ┘ └ ─ ─ ─ ─ ─ ─ ─ ─ ─ ┬ ─ ─ ─ ─ ─ ─ ─ ─ ┘ │ │ │ │ ┌ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ▼ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ┐ │ │ │ │ │ │ ┌───────────▼──────────┐ ┌───────────▼──────────┐ │ DataStorageWorker1 │ │ DataStorageWorker2 │ │ (Crawler1) │ │ (Crawler2) │ └──────────────────────┘ └──────────────────────┘","ref":"Crawly.DataStorage.html","title":"Crawly.DataStorage","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Crawly.DataStorage.html#child_spec/1","title":"Crawly.DataStorage.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Crawly.DataStorage.html#init/1","title":"Crawly.DataStorage.init/1","type":"function"},{"doc":"","ref":"Crawly.DataStorage.html#inspect/2","title":"Crawly.DataStorage.inspect/2","type":"function"},{"doc":"","ref":"Crawly.DataStorage.html#start_link/1","title":"Crawly.DataStorage.start_link/1","type":"function"},{"doc":"","ref":"Crawly.DataStorage.html#start_worker/2","title":"Crawly.DataStorage.start_worker/2","type":"function"},{"doc":"","ref":"Crawly.DataStorage.html#stats/1","title":"Crawly.DataStorage.stats/1","type":"function"},{"doc":"","ref":"Crawly.DataStorage.html#store/2","title":"Crawly.DataStorage.store/2","type":"function"},{"doc":"A worker process which stores items for individual spiders. All items are pre-processed by item_pipelines. All pipelines are using the state of this process for their internal needs (persistancy). The DataStorage.Worker will not write anything to a filesystem. Instead it would expect that pipelines are going to do that work.","ref":"Crawly.DataStorage.Worker.html","title":"Crawly.DataStorage.Worker","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Crawly.DataStorage.Worker.html#child_spec/1","title":"Crawly.DataStorage.Worker.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Crawly.DataStorage.Worker.html#init/1","title":"Crawly.DataStorage.Worker.init/1","type":"function"},{"doc":"Inspect the inner state of the given data worker","ref":"Crawly.DataStorage.Worker.html#inspect/2","title":"Crawly.DataStorage.Worker.inspect/2","type":"function"},{"doc":"","ref":"Crawly.DataStorage.Worker.html#start_link/1","title":"Crawly.DataStorage.Worker.start_link/1","type":"function"},{"doc":"","ref":"Crawly.DataStorage.Worker.html#stats/1","title":"Crawly.DataStorage.Worker.stats/1","type":"function"},{"doc":"","ref":"Crawly.DataStorage.Worker.html#store/2","title":"Crawly.DataStorage.Worker.store/2","type":"function"},{"doc":"Crawly Engine - process responsible for starting and stopping spiders. Stores all currently running spiders.","ref":"Crawly.Engine.html","title":"Crawly.Engine","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Crawly.Engine.html#child_spec/1","title":"Crawly.Engine.child_spec/1","type":"function"},{"doc":"","ref":"Crawly.Engine.html#get_crawl_id/1","title":"Crawly.Engine.get_crawl_id/1","type":"function"},{"doc":"","ref":"Crawly.Engine.html#get_manager/1","title":"Crawly.Engine.get_manager/1","type":"function"},{"doc":"","ref":"Crawly.Engine.html#get_spider_info/1","title":"Crawly.Engine.get_spider_info/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Crawly.Engine.html#init/1","title":"Crawly.Engine.init/1","type":"function"},{"doc":"","ref":"Crawly.Engine.html#list_known_spiders/0","title":"Crawly.Engine.list_known_spiders/0","type":"function"},{"doc":"","ref":"Crawly.Engine.html#refresh_spider_list/0","title":"Crawly.Engine.refresh_spider_list/0","type":"function"},{"doc":"","ref":"Crawly.Engine.html#running_spiders/0","title":"Crawly.Engine.running_spiders/0","type":"function"},{"doc":"","ref":"Crawly.Engine.html#start_link/1","title":"Crawly.Engine.start_link/1","type":"function"},{"doc":"Starts a spider. All options passed in the second argument will be passed along to the spider's init/1 callback. Reserved Options :crawl_id (binary). Optional, automatically generated if not set. :closespider_itemcount (integer | disabled). Optional, overrides the close spider item count on startup. :closespider_timeout (integer | disabled). Optional, overrides the close spider timeout on startup. :concurrent_requests_per_domain (integer). Optional, overrides the number of workers for a given spider Backward compatibility If the 2nd positional argument is a binary, it will be set as the :crawl_id . Deprecated, will be removed in the future.","ref":"Crawly.Engine.html#start_spider/2","title":"Crawly.Engine.start_spider/2","type":"function"},{"doc":"","ref":"Crawly.Engine.html#stop_spider/2","title":"Crawly.Engine.stop_spider/2","type":"function"},{"doc":"","ref":"Crawly.Engine.html#t:crawl_id_opt/0","title":"Crawly.Engine.crawl_id_opt/0","type":"type"},{"doc":"","ref":"Crawly.Engine.html#t:spider_info/0","title":"Crawly.Engine.spider_info/0","type":"type"},{"doc":"","ref":"Crawly.Engine.html#t:started_spiders/0","title":"Crawly.Engine.started_spiders/0","type":"type"},{"doc":"","ref":"Crawly.Engine.html#t:t/0","title":"Crawly.Engine.t/0","type":"type"},{"doc":"Crawler manager module This module is responsible for spawning all processes related to a given Crawler. The manager spawns the following processes tree. ┌────────────────┐ ┌───────────────────┐ │ Crawly.Manager ├────────&gt; Crawly.ManagerSup │ └────────────────┘ └─────────┬─────────┘ │ | │ | ┌ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ┤ │ │ │ │ ┌────────▼───────┐ ┌─────────▼───────┐ │ Worker1 │ │ Worker2 │ └────────┬───────┘ └────────┬────────┘ │ │ │ │ │ │ │ │ ┌────────▼─────────┐ ┌──────────▼───────────┐ │Crawly.DataStorage│ │Crawly.RequestsStorage│ └──────────────────┘ └──────────────────────┘","ref":"Crawly.Manager.html","title":"Crawly.Manager","type":"module"},{"doc":"","ref":"Crawly.Manager.html#add_workers/2","title":"Crawly.Manager.add_workers/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Crawly.Manager.html#child_spec/1","title":"Crawly.Manager.child_spec/1","type":"function"},{"doc":"","ref":"Crawly.Manager.html#start_link/1","title":"Crawly.Manager.start_link/1","type":"function"},{"doc":"Request storage, a module responsible for storing urls for crawling ┌ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ┐ │ │ ┌ -- -- -- -- -- -- -- -- -- ┐ │ RequestsStorage &lt; ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ┤ From crawlers1 , 2 │ │ │ └ -- -- -- -- -- -- -- -- -- ┘ └ ─ ─ ─ ─ ─ ─ ─ ─ ─ ┬ ─ ─ ─ ─ ─ ─ ─ ─ ┘ │ │ │ │ ┌ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ▼ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ─ ┐ │ │ │ │ │ │ ┌───────────▼──────────┐ ┌───────────▼──────────┐ │RequestsStorageWorker1│ │RequestsStorageWorker2│ │ (Crawler1) │ │ (Crawler2) │ └──────────────────────┘ └──────────────────────┘ All requests are going through one RequestsStorage process, which quickly finds the actual worker, which finally stores the request afterwords.","ref":"Crawly.RequestsStorage.html","title":"Crawly.RequestsStorage","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Crawly.RequestsStorage.html#child_spec/1","title":"Crawly.RequestsStorage.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Crawly.RequestsStorage.html#init/1","title":"Crawly.RequestsStorage.init/1","type":"function"},{"doc":"Pop a request out of requests storage","ref":"Crawly.RequestsStorage.html#pop/1","title":"Crawly.RequestsStorage.pop/1","type":"function"},{"doc":"","ref":"Crawly.RequestsStorage.html#requests/1","title":"Crawly.RequestsStorage.requests/1","type":"function"},{"doc":"","ref":"Crawly.RequestsStorage.html#start_link/1","title":"Crawly.RequestsStorage.start_link/1","type":"function"},{"doc":"Starts a worker for a given spider","ref":"Crawly.RequestsStorage.html#start_worker/2","title":"Crawly.RequestsStorage.start_worker/2","type":"function"},{"doc":"Get statistics from the requests storage","ref":"Crawly.RequestsStorage.html#stats/1","title":"Crawly.RequestsStorage.stats/1","type":"function"},{"doc":"Store individual request or multiple requests in related child worker","ref":"Crawly.RequestsStorage.html#store/2","title":"Crawly.RequestsStorage.store/2","type":"function"},{"doc":"Requests Storage, is a module responsible for storing requests for a given spider. Automatically filters out already seen requests (uses fingerprints approach to detect already visited pages). Pipes all requests through a list of middlewares, which do pre-processing of all requests before storing them","ref":"Crawly.RequestsStorage.Worker.html","title":"Crawly.RequestsStorage.Worker","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Crawly.RequestsStorage.Worker.html#child_spec/1","title":"Crawly.RequestsStorage.Worker.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Crawly.RequestsStorage.Worker.html#init/1","title":"Crawly.RequestsStorage.Worker.init/1","type":"function"},{"doc":"Pop a request out of requests storage","ref":"Crawly.RequestsStorage.Worker.html#pop/1","title":"Crawly.RequestsStorage.Worker.pop/1","type":"function"},{"doc":"Returns all scheduled requests (used for some sort of preview)","ref":"Crawly.RequestsStorage.Worker.html#requests/1","title":"Crawly.RequestsStorage.Worker.requests/1","type":"function"},{"doc":"","ref":"Crawly.RequestsStorage.Worker.html#start_link/2","title":"Crawly.RequestsStorage.Worker.start_link/2","type":"function"},{"doc":"Get statistics from the requests storage","ref":"Crawly.RequestsStorage.Worker.html#stats/1","title":"Crawly.RequestsStorage.Worker.stats/1","type":"function"},{"doc":"Store individual request or multiple requests","ref":"Crawly.RequestsStorage.Worker.html#store/2","title":"Crawly.RequestsStorage.Worker.store/2","type":"function"},{"doc":"A worker process responsible for the actual work (fetching requests, processing responses)","ref":"Crawly.Worker.html","title":"Crawly.Worker","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Crawly.Worker.html#child_spec/1","title":"Crawly.Worker.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Crawly.Worker.html#init/1","title":"Crawly.Worker.init/1","type":"function"},{"doc":"","ref":"Crawly.Worker.html#start_link/1","title":"Crawly.Worker.start_link/1","type":"function"},{"doc":"Basic Concepts","ref":"basic_concepts.html","title":"Basic Concepts","type":"extras"},{"doc":"Data is fetched in a linear series of operations. New Request s is formed through Crawly.Spider.init/0 . New Request s are pre-processed individually. Data is fetched, and a Response is returned The Spider receives the response and parses the response, returning new Request s and new parsed items Parsed items are post-processed individually. New Request s from the Spider goes to step 2","ref":"basic_concepts.html#flow-from-request-response-parsed-item","title":"Basic Concepts - Flow from Request, Response, Parsed Item","type":"extras"},{"doc":"Spiders are modules which define how a certain site (or a group of sites) will be scraped, including how to perform the crawl (i.e. follow links) and how to extract structured data from their pages (i.e. scraping items). In other words, Spiders are the place where you define the custom behaviour for crawling and parsing pages for a particular site. For spiders, the scraping cycle goes through something like this: You start by generating the initial Requests to crawl the first URLs, and use a callback function called with the response downloaded from those requests. In the callback function, you parse the response (web page) and return a %Crawly.ParsedItem{} struct. This struct should contain new requests to follow and items to be stored. In the callback functions, you parse the page contents, typically using Floki (but you can also use any other library you prefer) and generate items with the parsed data. Spiders are executed in the context of Crawly.Worker processes, and you can control the amount of concurrent workers via concurrent_requests_per_domain setting. All requests are being processed sequentially and are pre-processed by Middlewares. All items are processed sequentially and are processed by Item pipelines. Behaviour functions In order to make a working web crawler, all the behaviour callbacks need to be implemented. init() - a part of the Crawly.Spider behaviour. This function should return a KVList which contains a start_urls entry with a list, which defines the starting requests made by Crawly. Alternatively you may provide start_requests if it's required to prepare first requests on init() . Which might be useful if, for example, you want to pass a session cookie to the starting request. Note: start_requests are processed before start_urls. ** This callback is going to be deprecated in favour of init/1. For now the backwards compatibility is kept with a help of macro which always generates init/1 . init(options) same as init/0 but also takes options (which can be passed from the engine during the spider start). base_url() - defines a base_url of the given Spider. This function is used by the DomainFilter in order to filter out all requests which are going outside of the crawled website. parse_item(response) - a function which defines how a given response is translated into the Crawly.ParsedItem structure. On the high level this function defines the extraction rules for both Items and Requests.","ref":"basic_concepts.html#spiders","title":"Basic Concepts - Spiders","type":"extras"},{"doc":"Crawly uses Request and Response objects for crawling web sites. Typically, Request objects are generated in the spiders and pass across the system until they reach the Crawly.Worker process, which executes the request and returns a Response object which travels back to the spider that issued the request. The Request objects are being modified by the selected Middlewares, before hitting the worker. The request is defined as the following structure: @type t :: % Crawly.Request { url : binary ( ) , headers : [ header ( ) ] , prev_response : %{ } , options : [ option ( ) ] } @type header ( ) :: { key ( ) , value ( ) } Where: url - is the url of the request headers - define http headers which are going to be used with the given request options - would define options (like follow redirects). Crawly uses HTTPoison library to perform the requests, but we have plans to extend the support with other pluggable backends like selenium and others. Responses are defined in the same way as HTTPoison responses. See more details here: https://hexdocs.pm/httpoison/HTTPoison.Response.html#content","ref":"basic_concepts.html#requests-and-responses","title":"Basic Concepts - Requests and Responses","type":"extras"},{"doc":"ParsedItem is a structure which is filled by the parse_item/1 callback of the Spider. The structure is defined in the following way: @type item ( ) :: %{ } @type t :: % __MODULE__ { items : [ item ( ) ] , requests : [ Crawly.Request . t ( ) ] } The parsed item is being processed by Crawly.Worker process, which sends all requests to the Crawly.RequestsStorage process, responsible for pre-processing requests and storing them for the future execution, all items are being sent to Crawly.DataStorage process, which is responsible for pre-processing items and storing them on disk. For now only one Storage backend is supported (writing on disc). But in future Crawly will also support work with amazon S3, sql and others.","ref":"basic_concepts.html#parsed-item","title":"Basic Concepts - Parsed Item","type":"extras"},{"doc":"Crawly is using a concept of pipelines when it comes to processing of the elements sent to the system. This is applied to both request and scraped item manipulation. Conceptually, requests go through a series of manipulations, before the response is fetched. The response then goes through another different series of manipulations. Importantly, the way that requests and responses are manipulated are abstracted into the Crawly.Pipeline behaviour. This allows for a modular system for declaring changes. It is also to be noted that Each Crawly.Pipeline module, when declared, are applied sequentially through the Crawly.Utils.pipe/3 function. Writing Tests for Custom Pipelines Modules that implement the Crawly.Pipeline behaviour can make use of the Crawly.Utils.pipe/3 function to test for expected behaviour. Refer to the function documentation for more information and examples.","ref":"basic_concepts.html#the-crawly-pipeline-behaviour","title":"Basic Concepts - The Crawly.Pipeline Behaviour.","type":"extras"},{"doc":"These are configured under the middlewares option. See configuration for more details. Middleware: A pipeline module that modifies a request. It implements the Crawly.Pipeline behaviour. Middlewares are able to make changes to the underlying request, a Crawly.Request struct. The request, along with any options specified, is then passed to the fetcher (currently HTTPoison ). The available configuration options should correspond to the underlying options of the fetcher in use. Note that all request configuration options for HTTPoison , such as proxy, ssl, etc can be configured through Crawly.Request.options . Built-in middlewares: Crawly.Middlewares.DomainFilter - this middleware will disable scheduling for all requests leading outside of the crawled site, based on base_url. Crawly.Middlewares.SameDomainFilter - this middleware filters by domain as well but does not require base_url to be set, instead the start_url is considered. Crawly.Middlewares.RobotsTxt - this middleware ensures that Crawly respects the robots.txt defined by the target website. Crawly.Middlewares.UniqueRequest - this middleware ensures that crawly will not schedule the same URL (request) multiple times. Optionally supports hashing to reduce the memory footprint. Crawly.Middlewares.UserAgent - this middleware is used to set a User Agent HTTP header. Allows to rotate UserAgents, if the last one is defined as a list. Crawly.Middlewares.RequestOptions - allows to set additional request options, for example timeout, of proxy string (at this moment the options should match options of the individual fetcher (e.g. HTTPoison)) Crawly.Middlewares.AutoCookiesManager - allows to turn on the automatic cookies management. Useful for cases when you need to login or enter form data used by a website. Example: { Crawly.Middlewares.RequestOptions , [ timeout : 30_000 , recv_timeout : 15000 ] } , Crawly.Middlewares.AutoCookiesManager Response Parsers Item Pipelines: a pipeline module that parses a fetcher's request. If declared, a spider's c:Crawly.Spider.parse_item\\1 callback is ignored. It is unused by default. It implements the Crawly.Pipeline behaviour. Parsers allow for logic reuse when spiders parse a fetcher's response. Item Pipelines Item Pipelines: a pipeline module that modifies and pre-processes a scraped item. It implements the Crawly.Pipeline behaviour. Built-in item pipelines: Crawly.Pipelines.Validate - validates that a given item has all the required fields. All items which don't have all required fields are dropped. Crawly.Pipelines.DuplicatesFilter - filters out items which are already stored the system. Crawly.Pipelines.JSONEncoder - converts items into JSON format. Crawly.Pipelines.CSVEncoder - converts items into CSV format. Crawly.Pipelines.WriteToFile - Writes information to a given file. The list of item pipelines used with a given project is defined in the project settings.","ref":"basic_concepts.html#request-middlewares","title":"Basic Concepts - Request Middlewares","type":"extras"},{"doc":"Both item pipelines and request middlewares follows the Crawly.Pipeline behaviour. As such, when creating your custom pipeline, it will need to implement the required callback c:Crawly.Pipeline.run\\3 . The c:Crawly.Pipeline.run\\3 callback receives the processed item, item from the previous pipeline module as the first argument. The second argument, state , is a map containing information such as spider which the item originated from (under the :spider_name key), and may optionally store pipeline information. Finally, opts is a keyword list containing any tuple-based options. Passing Configuration Options To Your Pipeline Tuple-based option declaration is supported, similar to how a GenServer is declared in a supervision tree. This allows for pipeline reusability for different use cases. For example, you can pass options in this way through your pipeline declaration: pipelines : [ { MyCustomPipeline , my_option : &quot;value&quot; } ] In your pipeline, you will then receive the options passed through the opts argument. defmodule MyCustomPipeline do @impl Crawly.Pipeline def run ( item , state , opts ) do IO . inspect ( opts ) # shows keyword list of [ my_option: &quot;value&quot; ] # Do something end end Best Practices The use of global configs is discouraged, hence one should pass options through a tuple-based pipeline declaration where possible. When storing information in the state map, ensure that the state is namespaced with the pipeline name, so as to avoid key clashing. For example, to store state from MyEctoPipeline , store the state on the key :my_ecto_pipeline_my_state . Custom Request Middlewares Request Middleware Example - Add a Proxy Following the documentation for proxy options of a request in HTTPoison , we can do the following: defmodule MyApp.MyProxyMiddleware do @impl Crawly.Pipeline def run ( request , state , opts \\\\ [ ] ) do # Set default proxy and proxy_auth to nil opts = Enum . into ( opts , %{ proxy : nil , proxy_auth : nil } ) case opts . proxy do nil -&gt; # do nothing { request , state } value -&gt; old_options = request . options new_options = [ proxy : opts . proxy , proxy_auth : opts . proxy_auth ] new_request = Map . put ( request , :options , old_optoins ++ new_options ) { new_request , state } end end end Custom Item Pipelines Item pipelines receive the parsed item (from the Spider) and performs post-processing on the item. Storing Parsed Items You can use custom item pipelines to save the item to custom storages. Example - Ecto Storage Pipeline In this example, we insert the scraped item into a table with Ecto. This example does not directly call MyRepo.insert , but delegates it to an application context function. defmodule MyApp.MyEctoPipeline do @impl Crawly.Pipeline def run ( item , state , _opts \\\\ [ ] ) do case MyApp . insert_with_ecto ( item ) do { :ok , _ } -&gt; # insert successful, carry on with pipeline { item , state } { :error , _ } -&gt; # insert not successful, drop from pipeline { false , state } end end end Multiple Different Types of Parsed Items If you need to selectively post-process different types of scraped items, you can utilize pattern-matching at the item pipeline level. There are two general methods of doing so: Struct-based pattern matching defmodule MyApp.MyCustomPipeline do @impl Crawly.Pipeline def run ( % MyItem { } = item , state , _opts \\\\ [ ] ) do # do something end # do nothing if it does not match def run ( item , state , _opts ) , do : { item , state } end Key-based pattern matching defmodule MyApp.MyCustomPipeline do @impl Crawly.Pipeline def run ( %{ my_item : my_item } = item , state , _opts \\\\ [ ] ) do # do something end # do nothing if it does not match def run ( item , state , _opts ) , do : { item , state } end Use struct-based pattern matching when: you want to utilize existing Ecto schemas you have pre-defined structs that you want to conform to Use key-based pattern matching when: you want to process two or more related and inter-dependent items together you want to bulk process multiple items for efficiency reasons. For example, processing the weather data for 365 days in one pass. Caveats When using the nested-key pattern matching method, the spider's Crawly.Spider.parse_item/1 callback will need to return items with a single key (or a map with multiple keys, if doing related processing). When using struct-based pattern matching with existing Ecto structs, you will need to do an intermediate conversion of the struct into a map before performing the insertion into the Ecto Repo. This is due to the underlying Ecto schema metadata still being attached to the struct before insertion. Example - Multi-Item Pipelines With Pattern Matching In this example, your spider scrapes a &quot;blog post&quot; and a &quot;weather data&quot; from a website. We will use the key-based pattern matching approach to selectively post-process a blog post parsed item. # in MyApp.CustomSpider.ex def parse_item ( response ) : # parse my item %{ parsed_items : [ %{ blog_post : blog_post } , %{ weather : [ january_weather , february_weather ] } ] } Then, in the custom pipeline, we will pattern match on the :blog_post key, to ensure that we only process blog posts with this pipeline (and not weather data). We then update the :blog_post key of the received item. defmodule MyApp.BlogPostPipeline do @impl Crawly.Pipeline def run ( %{ blog_post : old_blog_post } = item , state , _opts \\\\ [ ] ) do # process the blog post updated_item = Map . put ( item , :blog_post , %{ my : &quot;data&quot; } ) { updated_item , state } end # do nothing if it does not match def run ( item , state , _opts ) , do : { item , state } end","ref":"basic_concepts.html#creating-a-custom-pipeline-module","title":"Basic Concepts - Creating a Custom Pipeline Module","type":"extras"},{"doc":"Browser rendering is one of the most complex problems of scraping. The Internet moves towards more dynamic content, where not only parts of the pages are loaded asynchronously, but entire applications might be rendered by JavaScript and AJAX. In most of the cases it's still possible to extract the data from dynamically rendered pages. (E.g. by sending additional POST requests from loaded pages), however this approach seems to have visible drawbacks. From our point of view it makes the spider code quite complicated and fragile. Of course it's good when you can just get pages already rendered for you. And we're solving this problem with a help of pluggable HTTP fetchers. Crawly's codebase contains a special Splash fetcher, which allows to do the browser rendering before the page content is being parsed by a spider. Also it's possible to build own fetchers. Using splash fetcher for browser rendering Splash is a lightweight opensourse browser implementation built with QT and python. See: https://splash.readthedocs.io/en/stable/api.html You can try using Splash with Crawly in the following way: Start splash locally (e.g. using a docker image): docker run -it -p 8050:8050 scrapinghub/splash --max-timeout 300 Configure Crawly to use Splash: fetcher: {Crawly.Fetchers.Splash, [base_url: &quot;http://localhost:8050/render.html&quot;]} Now all your pages will be automatically rendered by Splash.","ref":"basic_concepts.html#browser-rendering","title":"Basic Concepts - Browser rendering","type":"extras"},{"doc":"Configuration A basic example: config :crawly , pipelines : [ # my pipelines ] , middlewares : [ # my middlewares ]","ref":"configuration.html","title":"Configuration","type":"extras"},{"doc":"middlewares :: [module()] Defines a list of middlewares responsible for pre-processing requests. If any of the requests from the Crawly.Spider is not passing the middleware configuration on the middlewares key, it's dropped. Refer to Crawly.Pipeline for more information on the structure of a middleware. # Example middlewares config :crawly , middlewares : [ Crawly.Middlewares.DomainFilter , Crawly.Middlewares.UniqueRequest , Crawly.Middlewares.RobotsTxt , # With options { Crawly.Middlewares.UserAgent , user_agents : [ &quot;My Bot&quot; ] } , { Crawly.Middlewares.RequestOptions , [ timeout : 30_000 , recv_timeout : 15000 ] } ] parsers :: [module()] default: nil By default, parsers are unused, and a Crawly.Spider 's parse_item/1 will be called to parse a fetcher's response. However, it is possible utilize Crawly's built-in parsers or your own custom logic to parse responses from a fetcher. IMPORTANT : If set at the global, ALL spiders will not have their parse_item/1 callback used. It is advised to declare these at the non-global level using spider-level settings overrides. Each parser may have additional peer dependencies if used. Refer to the documentation for each parser to know the specific requirements for each. Refer to Crawly.Pipeline for more information on the structure of a parser. config :crawly , parsers : [ { Crawly.Parsers.ExtractRequests , selector : &quot;button&quot; } , ] pipelines :: [module()] default: [] Defines a list of pipelines responsible for pre processing all the scraped items. All items not passing any of the pipelines are dropped. If unset, all items are stored without any modifications. Refer to Crawly.Pipeline for more information on the structure of a pipeline. config :crawly , pipelines : [ { Crawly.Pipelines.Validate , fields : [ :id , :date ] } , { Crawly.Pipelines.DuplicatesFilter , item_id : :id } , Crawly.Pipelines.JSONEncoder , { Crawly.Pipelines.WriteToFile , extension : &quot;jl&quot; , folder : &quot;/tmp&quot; , include_timestamp : true } ] closespider_itemcount :: pos_integer() | :disabled default: :disabled An integer which specifies a number of items. If the spider scrapes more than that amount and those items are passed by the item pipeline, the spider will be closed. If set to :disabled the spider will not be stopped. closespider_timeout :: pos_integer() default: nil (disabled by default) Defines a minimal amount of items which needs to be scraped by the spider within the given timeframe (1m). If the limit is not reached by the spider - it will be stopped. concurrent_requests_per_domain :: pos_integer() default: 4 Indicates the number of Crawly workers that will be used to make simultaneous requests on a per-spider basis. Each Crawly worker is rate-limited to a maximum of 4 requests per minute. Hence, by default, the number of requests possible would be 4 x 4 = 16 req/min . In order to increase the number of requests made per minute, set this option to a higher value. The default value is intentionally set at 4 for ethical crawling reasons. NOTE: A worker's speed if often limited by the speed of the actual HTTP client and network bandwidth, and may be less than 4 requests per minute. retry :: Keyword list Allows to configure the retry logic. Accepts the following configuration options: retry_codes : Allows to specify a list of HTTP codes which are treated as failed responses. (Default: []) max_retries : Allows to specify the number of attempts before the request is abandoned. (Default: 0) ignored_middlewares : Allows to modify the list of processors for a given requests when retry happens. (Will be required to avoid clashes with Unique.Request middleware). Example: retry : [ retry_codes : [ 400 ] , max_retries : 3 , ignored_middlewares : [ Crawly.Middlewares.UniqueRequest ] ] fetcher :: atom() default: Crawly.Fetchers.HTTPoisonFetcher Allows to specify a custom HTTP client which will be performing request to the crawler target. log_dir :: String.t() default: /tmp Set spider logs directory. All spiders have their own dedicated log file stored under the log_dir folder. This option is ignored if log_to_file is not set to true . log_to_file :: String.t() default: false Enables or disables file logging. If set to true , make sure to add :logger_file_backend https://github.com/onkel-dirtus/logger_file_backend#loggerfilebackend as a dependency to your project. Here is an example of file logger configuration where logs from different spiders are separated into multiple files: config :logger , backends : [ { LoggerFileBackend , :info_log } ] config :crawly , log_dir : &quot;/tmp/spider_logs&quot; , log_to_file : true , ... ... other configurations port :: pos_integer() default: 4001 Allows to specify a custom port to start the application. That is important when running more than one application in a single machine, in which case shall not use the same port as the others. start_http_api? :: boolean() default: true Allows to switch on/off management interface of Crawly, that might be useful if you already have a server and want to use it to operate Crawly. For example if you have a phoenix application you can add the following lines to your router: defmodule MyApp.Router do use Plug.Router ... forward &quot;/crawlers&quot; , Crawly.API.Router ... end on_spider_closed_callback :: function() default: :ignored A function that takes three arguments: spider_name, crawl_id and reason of spider stop. Allows to define a callback function which will be executed when spider finishes it's work.","ref":"configuration.html#options","title":"Configuration - Options","type":"extras"},{"doc":"It's possible to override most of the setting on a spider level. In order to do that, it is required to define the override_settings/0 callback in your spider. For example: def override_settings ( ) do [ concurrent_requests_per_domain : 5 , closespider_timeout : 6 ] end The full list of overridable settings: closespider_itemcount, closespider_timeout, concurrent_requests_per_domain, fetcher, retry, parsers, middlewares (has known bugs ) pipelines","ref":"configuration.html#overriding-global-settings-on-spider-level","title":"Configuration - Overriding global settings on spider level","type":"extras"},{"doc":"HTTP API Crawly supports a basic HTTP API, which allows to control the Engine behaviour.","ref":"http_api.html","title":"HTTP API","type":"extras"},{"doc":"The following command will start a given Crawly spider: curl - v localhost : 4001 / spiders / &lt; spider_name &gt; / schedule","ref":"http_api.html#starting-a-spider","title":"HTTP API - Starting a spider","type":"extras"},{"doc":"The following command will stop a given Crawly spider: curl - v localhost : 4001 / spiders / &lt; spider_name &gt; / stop","ref":"http_api.html#stopping-a-spider","title":"HTTP API - Stopping a spider","type":"extras"},{"doc":"curl - v localhost : 4001 / spiders","ref":"http_api.html#getting-currently-running-spiders","title":"HTTP API - Getting currently running spiders","type":"extras"},{"doc":"curl - v localhost : 4001 / spiders / &lt; spider_name &gt; / scheduled - requests curl - v localhost : 4001 / spiders / &lt; spider_name &gt; / scraped - items","ref":"http_api.html#getting-spider-stats","title":"HTTP API - Getting spider stats","type":"extras"},{"doc":"Ethical Crawling It is important to be polite when performing web crawling. Avoid harming scraped websites. Scraping politely: A polite crawler respects robots.txt. A polite crawler never degrades a website’s performance. A polite crawler identifies its creator with contact information. A polite crawler is not a pain in the buttocks of system administrators.","ref":"ethical_aspects.html","title":"Ethical Crawling","type":"extras"},{"doc":"Experimental UI If you are interested in our attempts to make crawling more predictable, have a glance on: https://github.com/oltarasenko/crawly_ui","ref":"experimental_ui.html","title":"Experimental UI","type":"extras"},{"doc":"You can find setup examples here On the highest level it's required to: Add SendToUI pipeline to the list of your item pipelines (before encoder pipelines) {Crawly.Pipelines.Experimental.SendToUI, ui_node: :'ui@127.0.0.1'} Organize erlang cluster so Crawly nodes can find CrawlyUI node in the example above I was using erlang-node-discovery application for this task, however any other alternative would also work. For setting up erlang-node-discovery add the following code dependency to deps section of mix.exs {:erlang_node_discovery, git: &quot;https://github.com/oltarasenko/erlang-node-discovery&quot;} add the following lines to the config.exs: config :erlang_node_discovery, hosts: [&quot;127.0.0.1&quot;, &quot;crawlyui.com&quot;], node_ports: [ {:ui, 0} ]","ref":"experimental_ui.html#setting-it-up","title":"Experimental UI - Setting it up","type":"extras"},{"doc":"You can send logs to CrawlyUI as well. In order to do that you have to add the following (changing your node name of course) to your config: # tell logger to load a LoggerFileBackend processes config :logger , backends : [ :console , { Crawly.Loggers.SendToUiBackend , :send_log_to_ui } ] , level : :debug config :logger , :send_log_to_ui , destination : { :&quot;ui@127.0.0.1&quot; , CrawlyUI , :store_log }","ref":"experimental_ui.html#setting-up-logger","title":"Experimental UI - Setting up logger","type":"extras"},{"doc":"Running Crawly as a standalone application An approach that involves abstracting all scraping tasks into a separate entity (or service), thereby allowing you to extract your desired data without the need for Crawly in your mix file. In other words: Run Crawly as a Docker container with spiders mounted from the outside . Getting started Here we will show how re-implement the example from Quickstart, to achieve the same results with a standalone version of Crawly. Make a folder for your project: mkdir myproject Make spiders folder inside the project folder: mkdir ./myproject/spiders Copy the spider code inside a file in a folder defined on the previous step myproject/spiders/books_to_scrape.ex : defmodule BooksToScrape do use Crawly.Spider @impl Crawly.Spider def base_url ( ) , do : &quot;https://books.toscrape.com/&quot; @impl Crawly.Spider def init ( ) do [ start_urls : [ &quot;https://books.toscrape.com/&quot; ] ] end @impl Crawly.Spider def parse_item ( response ) do # Parse response body to document { :ok , document } = Floki . parse_document ( response . body ) # Create item (for pages where items exists) items = document |&gt; Floki . find ( &quot;.product_pod&quot; ) |&gt; Enum . map ( fn x -&gt; %{ title : Floki . find ( x , &quot;h3 a&quot; ) |&gt; Floki . attribute ( &quot;title&quot; ) |&gt; Floki . text ( ) , price : Floki . find ( x , &quot;.product_price .price_color&quot; ) |&gt; Floki . text ( ) , url : response . request_url } end ) next_requests = document |&gt; Floki . find ( &quot;.next a&quot; ) |&gt; Floki . attribute ( &quot;href&quot; ) |&gt; Enum . map ( fn url -&gt; Crawly.Utils . build_absolute_url ( url , response . request . url ) |&gt; Crawly.Utils . request_from_url ( ) end ) %{ items : items , requests : next_requests } end end Now create a configuration file using erlang.config format: https://www.erlang.org/doc/man/config.html For example: myproject/crawly.config [ { crawly , [ { closespider_itemcount , 500 } , { closespider_timeout , 20 } , { concurrent_requests_per_domain , 2 } , { middlewares , [ &#39;Elixir.Crawly.Middlewares.DomainFilter&#39; , &#39;Elixir.Crawly.Middlewares.UniqueRequest&#39; , &#39;Elixir.Crawly.Middlewares.RobotsTxt&#39; , { &#39;Elixir.Crawly.Middlewares.UserAgent&#39; , [ { user_agents , [ &lt;&lt; &quot;Crawly BOT&quot; &gt;&gt; ] } ] } ] } , { pipelines , [ { &#39;Elixir.Crawly.Pipelines.Validate&#39; , [ { fields , [ title , url ] } ] } , { &#39;Elixir.Crawly.Pipelines.DuplicatesFilter&#39; , [ { item_id , title } ] } , { &#39;Elixir.Crawly.Pipelines.JSONEncoder&#39; } , { &#39;Elixir.Crawly.Pipelines.WriteToFile&#39; , [ { folder , &lt;&lt; &quot;/tmp&quot; &gt;&gt; } , { extension , &lt;&lt; &quot;jl&quot; &gt;&gt; } ] } ] } ] } ] . Now lets start the Crawly (First pull it from DockerHub: docker pull oltarasenko/crawly:0.15.0 ): docker run -- name crawly - e &quot;SPIDERS_DIR=/app/spiders&quot; \\ - it - p 4001 : 4001 - v $ ( pwd ) / spiders :/ app / spiders \\ - v $ ( pwd ) / crawly . config :/ app / config / crawly . config \\ crawly You can either fetch the latest version of Crawly from DockerHub or built it yourself ( docker build -t crawly . ) ** SPIDERS_DIR environment variable specifies a folder from which additional spiders are going to be fetched. ./spiders is used by default Open Crawly Web Management interface in your browser: https://localhost:4001/ Here it's possible to Schedule a spider with a use of Schedule button. The interface also allows you to access other useful information like: History of your jobs Items Logs of the given spider","ref":"standalone_crawly.html","title":"Running Crawly as a standalone application","type":"extras"},{"doc":"Defining spiders in YML Starting from version 0.15.0, Crawly has added the possibility to define spiders as YML files directly from Crawly’s management interface. The main idea is to reduce the amount of boilerplate when defining simple spiders. You should not write code to get titles and descriptions from Reddit (we hope :)","ref":"spiders_in_yml.html","title":"Defining spiders in YML","type":"extras"},{"doc":"Start the Crawly application (either using the classical, dependency-based approach or as a standalone application) Open Crawly Management interface (localhost:4001) Define the spider using the following structure: name: BooksSpiderForTest base_url: &quot;https://books.toscrape.com/&quot; start_urls: - &quot;https://books.toscrape.com/catalogue/a-light-in-the-attic_1000/index.html&quot; fields: - name: title selector: &quot;.product_main&quot; - name: price selector: &quot;.product_main .price_color&quot; links_to_follow: - selector: &quot;a&quot; attribute: &quot;href&quot; Click Preview button, to see how extracted data will look like after the spider is created: Now after saving the spider it will be possible to Schedule the spider using the Crawly Management interface.","ref":"spiders_in_yml.html#quickstart","title":"Defining spiders in YML - Quickstart","type":"extras"},{"doc":"&quot;name&quot; (required): A string representing the name of the scraper. &quot;base_url&quot; (required): A string representing the base URL of the website being scraped. The value must be a valid URI. &quot;start_urls&quot; (required): An array of strings representing the URLs to start scraping from. Each URL must be a valid URI. &quot;links_to_follow&quot; (required): An array of objects representing the links to follow when scraping a page. Each object must have the following properties: &quot;selector&quot;: A string representing the CSS selector for the links to follow. &quot;attribute&quot;: A string representing the attribute of the link element that contains the URL to follow. &quot;fields&quot; (required): An array of objects representing the fields to scrape from each page. Each object must have the following properties: &quot;name&quot;: A string representing the name of the field. &quot;selector&quot;: A string representing the CSS selector for the field to scrape.","ref":"spiders_in_yml.html#yml-spider-structure","title":"Defining spiders in YML - YML Spider Structure","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS","ref":"license.html","title":"License","type":"extras"},{"doc":"Crawly","ref":"readme.html","title":"Introduction","type":"extras"},{"doc":"Crawly is an application framework for crawling web sites and extracting structured data which can be used for a wide range of useful applications, like data mining, information processing or historical archival.","ref":"readme.html#overview","title":"Introduction - Overview","type":"extras"},{"doc":"Elixir ~&gt; 1.14 Works on GNU/Linux, Windows, macOS X, and BSD.","ref":"readme.html#requirements","title":"Introduction - Requirements","type":"extras"},{"doc":"Create a new project: mix new quickstart --sup Add Crawly as a dependencies: # mix.exs defp deps do [ { :crawly , &quot;~&gt; 0.16.0&quot; } , { :floki , &quot;~&gt; 0.33.0&quot; } ] end Fetch dependencies: $ mix deps.get Create a spider # lib/crawly_example/books_to_scrape.ex defmodule BooksToScrape do use Crawly.Spider @impl Crawly.Spider def base_url ( ) , do : &quot;https://books.toscrape.com/&quot; @impl Crawly.Spider def init ( ) do [ start_urls : [ &quot;https://books.toscrape.com/&quot; ] ] end @impl Crawly.Spider def parse_item ( response ) do # Parse response body to document { :ok , document } = Floki . parse_document ( response . body ) # Create item (for pages where items exists) items = document |&gt; Floki . find ( &quot;.product_pod&quot; ) |&gt; Enum . map ( fn x -&gt; %{ title : Floki . find ( x , &quot;h3 a&quot; ) |&gt; Floki . attribute ( &quot;title&quot; ) |&gt; Floki . text ( ) , price : Floki . find ( x , &quot;.product_price .price_color&quot; ) |&gt; Floki . text ( ) , url : response . request_url } end ) next_requests = document |&gt; Floki . find ( &quot;.next a&quot; ) |&gt; Floki . attribute ( &quot;href&quot; ) |&gt; Enum . map ( fn url -&gt; Crawly.Utils . build_absolute_url ( url , response . request . url ) |&gt; Crawly.Utils . request_from_url ( ) end ) %{ items : items , requests : next_requests } end end New in 0.15.0 : It's possible to use the command to speed up the spider creation, so you will have a generated file with all needed callbacks: mix crawly.gen.spider --filepath ./lib/crawly_example/books_to_scrape.ex --spidername BooksToScrape Configure Crawly By default, Crawly does not require any configuration. But obviously you will need a configuration for fine tuning the crawls: (in file: config/config.exs ) import Config config :crawly , closespider_timeout : 10 , concurrent_requests_per_domain : 8 , closespider_itemcount : 100 , middlewares : [ Crawly.Middlewares.DomainFilter , Crawly.Middlewares.UniqueRequest , { Crawly.Middlewares.UserAgent , user_agents : [ &quot;Crawly Bot&quot; ] } ] , pipelines : [ { Crawly.Pipelines.Validate , fields : [ :url , :title , :price ] } , { Crawly.Pipelines.DuplicatesFilter , item_id : :title } , Crawly.Pipelines.JSONEncoder , { Crawly.Pipelines.WriteToFile , extension : &quot;jl&quot; , folder : &quot;/tmp&quot; } ] New in 0.15.0: You can generate example config with the help of the following command: mix crawly.gen.config Start the Crawl: iex -S mix run -e &quot;Crawly.Engine.start_spider(BooksToScrape)&quot; Results can be seen with: $ cat /tmp/BooksToScrape_&lt;timestamp&gt;.jl","ref":"readme.html#quickstart","title":"Introduction - Quickstart","type":"extras"},{"doc":"It's possible to run Crawly in a standalone mode, when Crawly is running as a tiny docker container, and spiders are just YMLfiles or elixir modules that are mounted inside. Please read more about it here: Standalone Crawly Spiders as YML","ref":"readme.html#running-crawly-without-elixir-or-elixir-projects","title":"Introduction - Running Crawly without Elixir or Elixir projects","type":"extras"},{"doc":"Please use discussions for all conversations related to the project","ref":"readme.html#need-more-help","title":"Introduction - Need more help?","type":"extras"},{"doc":"Crawly can be configured in the way that all fetched pages will be browser rendered, which can be very useful if you need to extract data from pages which has lots of asynchronous elements (for example parts loaded by AJAX). You can read more here: Browser Rendering","ref":"readme.html#browser-rendering","title":"Introduction - Browser rendering","type":"extras"},{"doc":"Crawly provides a simple management UI by default on the localhost:4001 It allows to: Start spiders Stop spiders Preview scheduled requests View/Download items extracted View/Download logs NOTE: It's possible to disable the Simple management UI (and rest API) with the start_http_api?: false options of Crawly configuration. You can choose to run the management UI as a plug in your application. defmodule MyApp.Router do use Plug.Router ... forward &quot;/admin&quot; , Crawly.API.Router ... end","ref":"readme.html#simple-management-ui-new-in-0-15-0-management-ui","title":"Introduction - Simple management UI (New in 0.15.0) {#management-ui}","type":"extras"},{"doc":"Now don't have a possibility to work on experimental UI built with Phoenix and LiveViews, and keeping it here for mainly demo purposes. The CrawlyUI project is an add-on that aims to provide an interface for managing and rapidly developing spiders. Checkout the code from GitHub","ref":"readme.html#experimental-ui-deprecated","title":"Introduction - Experimental UI [Deprecated]","type":"extras"},{"doc":"API Reference Quickstart","ref":"readme.html#documentation","title":"Introduction - Documentation","type":"extras"},{"doc":"To be discussed","ref":"readme.html#roadmap","title":"Introduction - Roadmap","type":"extras"},{"doc":"Blog post on Erlang Solutions website: https://www.erlang-solutions.com/blog/web-scraping-with-elixir.html Blog post about using Crawly inside a machine learning project with Tensorflow (Tensorflex): https://www.erlang-solutions.com/blog/how-to-build-a-machine-learning-project-in-elixir.html Web scraping with Crawly and Elixir. Browser rendering: https://medium.com/@oltarasenko/web-scraping-with-elixir-and-crawly-browser-rendering-afcaacf954e8 Web scraping with Elixir and Crawly. Extracting data behind authentication: https://oltarasenko.medium.com/web-scraping-with-elixir-and-crawly-extracting-data-behind-authentication-a52584e9cf13 What is web scraping, and why you might want to use it? Using Elixir and Crawly for price monitoring Building a Chrome-based fetcher for Crawly","ref":"readme.html#articles","title":"Introduction - Articles","type":"extras"},{"doc":"Blog crawler: https://github.com/oltarasenko/crawly-spider-example E-commerce websites: https://github.com/oltarasenko/products-advisor Car shops: https://github.com/oltarasenko/crawly-cars JavaScript based website (Splash example): https://github.com/oltarasenko/autosites","ref":"readme.html#example-projects","title":"Introduction - Example projects","type":"extras"},{"doc":"We would gladly accept your contributions!","ref":"readme.html#contributors","title":"Introduction - Contributors","type":"extras"},{"doc":"Please find documentation on the HexDocs","ref":"readme.html#documentation","title":"Introduction - Documentation","type":"extras"},{"doc":"Using Crawly on production? Please let us know about your case!","ref":"readme.html#production-usages","title":"Introduction - Production usages","type":"extras"},{"doc":"Copyright (c) 2019 Oleg Tarasenko Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#copyright-and-license","title":"Introduction - Copyright and License","type":"extras"},{"doc":"Update version in mix.exs Update version in quickstart (README.md, this file) Commit and create a new tag: git commit &amp;&amp; git tag 0.xx.0 &amp;&amp; git push origin master --follow-tags Build docs: mix docs Publish hex release: mix hex.publish","ref":"readme.html#how-to-release","title":"Introduction - How to release:","type":"extras"}]